package Satisfiability;

import java.util.*;
import backTrack.*;

public class Application {

	  public static class BooleanFormula implements Satisfiability.Formula {
	  	private Map assignment = new HashMap();
	  	
	  	private boolean v(String x) {
	  		return ((Boolean)assignment.get(x)).booleanValue();
	  	}
	  	
	  	public boolean evaluate(Map aspectAssignment) {
	  		//Convert Map[Aspect]->Boolean to Map[String]->Boolean
	  		assignment.clear();
	  		for (Iterator i = aspectAssignment.entrySet().iterator(); i.hasNext(); ) {
	  			Map.Entry m = (Map.Entry)i.next();
	  			assignment.put( ((Satisfiability.Aspect)m.getKey()).getVariable(), m.getValue());
	  		}
	  		return (v("a") || v("b")) && (!v("a") || v("c"));
	  	}
	  	
	    public Collection getVariables() {
	    	Collection vs = new HashSet();
	    	vs.add("a");
	    	vs.add("b");
	    	vs.add("c");
	    	return vs;
	  	}
	    
	    public String toString () {
	    	return "(a || b) && (!a || c)";
	    }
	  }
	  
	  
    public static void main(String[] args) {
    	BooleanFormula toSolve = new BooleanFormula();
      Satisfiability problem = new Satisfiability (toSolve,toSolve.getVariables());
      Map solution = Solver.solveIt(problem);
      System.out.println("\n\nSolution to: " + toSolve);
      System.out.println(Solver.illustrateSolution(solution));
    
      /*BooleanFormula*/ problem = new Satisfiability (toSolve,toSolve.getVariables());
      Collection solutions = Solver.solveAll(problem);
      System.out.println("\n\nSolution to: " + toSolve);
      System.out.println("\n\n# Solutions = " + solutions.size());
      int count = 1;
      for (Iterator i = solutions.iterator(); i.hasNext(); )
        System.out.println("\n\nSolution #" + count++ + " " + Solver.illustrateSolution((Map)i.next()));
}

}
