package Sudoku;

import java.io.EOFException;
import java.util.*;
import backTrack.*;
import edu.cmu.cs.pattis.cs151xx.TypedBufferReader;
import edu.cmu.cs.pattis.cs151xx.Timer;

public class Application {

	public static void printPuzzle (String message, int[][] puzzle) {
		System.out.println(message);
		for (int r = 0; r < 9; r++) {
			System.out.print(r%3==0?"\n":"");
			for (int c = 0; c < 9; c++)
				System.out.print((c%3==0?" ":"") + puzzle[r][c]);
			System.out.println();
		}
	}
	
	public static int[][] readPuzzle () {
		int[][] puzzle = new int[9][9];
		TypedBufferReader tbr = new TypedBufferReader("Enter puzzle file name");
		try {
			for (int r = 0; r < 9; r++)
				for (int c = 0; c < 9; c++)
					puzzle[r][c] = tbr.readInt();
			int noMore = tbr.readInt();
		} catch (EOFException e) { //expected: do nothing
	  } catch (Exception e) {
		  throw new IllegalStateException("Input file error");
	  }
		return puzzle;
	}
	
	public static void main(String[] args) {
		int[][] puzzle = new int[9][9];

    puzzle = readPuzzle();
		printPuzzle("Original puzzle:",puzzle);
		
		Sudoku problem = new Sudoku(puzzle);
		Timer t = new Timer();
		t.start();
		Map solution = Solver.solveIt(problem);
		t.stop();
		for (Iterator i = solution.entrySet().iterator(); i.hasNext(); ) {
			Map.Entry e = (Map.Entry)i.next();
			Sudoku.Aspect k = (Sudoku.Aspect)e.getKey();
			Integer v = (Integer)e.getValue();
			puzzle[k.getRow()][k.getCol()] = v.intValue();
		}
		printPuzzle("\n\nSolution:",puzzle);
		System.out.println("\nSolution time = " + t.getElapsed() + " secs");
	}

}
