package backTrack;

import java.util.*;

public class Solver {

	public static String illustrateSolution (Map assignments) {
		if (assignments == null)
			return "No solution found";
		
		String solution = "Bindings:";
		for (Iterator i = assignments.entrySet().iterator(); i.hasNext();) {
			  Map.Entry binding = (Map.Entry)i.next();
			  solution += "\n" + ((Problem.Aspect)binding.getKey()).assignmentTo(binding.getValue());
		}
	  return solution;
	}

	
	public static Map solveIt (Problem problem) { 
		try {
			Problem.Aspect aspect = problem.chooseAndExcludeAspect();
			
      for (Iterator i=aspect.iterator(); i.hasNext();) {
        Object value = i.next();
        problem.assignAspectValue(aspect, value);
     	  Map temp = solveIt (problem.copy());
     	  if (temp != null)
     		  return temp;
     	  problem.removeAspectValue(aspect);
      } 
		} catch (Succeed s){return problem.getSolution();}
		  catch (Fail    f){return null;}
		return null;
	 }
	
	
	private static Collection solutions = new HashSet();
	
	public static Collection solveAll (Problem problem) { 
		try {
			Problem.Aspect aspect = problem.chooseAndExcludeAspect();
			
      for (Iterator i=aspect.iterator(); i.hasNext();) {
      	Object value = i.next();
        problem.assignAspectValue(aspect, value);
     	  solveAll (problem.copy());
     	  problem.removeAspectValue(aspect);
      } 
		} catch (Succeed s){solutions.add(problem.getSolution());}
		  catch (Fail    f){}
		return solutions;
	 }
}
